unit MainFrm;

interface

uses
  btHabariExpress, BTJMSInterfaces, BTCommAdapterIndy,
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnList, ToolWin, ActnMan, ActnCtrls, XPStyleActnCtrls, ImgList,
  ComCtrls, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    ActionManager1: TActionManager;
    ActionToolBar1: TActionToolBar;
    ActionConnect: TAction;
    ActionOptions: TAction;
    ImageList1: TImageList;
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    MemoChat: TMemo;
    ActionSend: TAction;

    procedure ActionConnectExecute(Sender: TObject);
    procedure ActionOptionsExecute(Sender: TObject);
    procedure ActionSendExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private-Deklarationen }
    HabariExpress: THabariExpress;
    NickName: string;
    procedure SendPublicInfo(const MsgText: string);
    procedure OnTextMessage(Sender: TObject; const JMSMessage: ITextMessage);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

uses
  BTJMSConnectionFactory;

{$R *.dfm}

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if ActionConnect.Checked then
    ActionConnectExecute(Sender);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  HabariExpress := THabariExpress.Create(Self);
  HabariExpress.OptionsDestination.DestinationType := dtTopic;
  HabariExpress.OnTextMessage := OnTextMessage;
end;

procedure TForm1.OnTextMessage(Sender: TObject; const JMSMessage: ITextMessage);
var
  SenderNick: string;
begin
  SenderNick := JMSMessage.Properties.GetString('nickname');
  if SenderNick <> '' then
    MemoChat.Lines.Add(SenderNick + ': ' + JMSMessage.Text)
  else
    MemoChat.Lines.Add(JMSMessage.Text)
end;

procedure TForm1.SendPublicInfo(const MsgText: string);
var
  Msg: IMessage;
begin
  Msg := HabariExpress.Session.CreateTextMessage(MsgText);
  HabariExpress.MessageProducer.Send(Msg);
end;

procedure TForm1.ActionConnectExecute(Sender: TObject);
var
  TopicName: string;
begin
  if not ActionConnect.Checked then
  begin
    ActionConnect.Caption := 'Disconnect';
    ActionConnect.ImageIndex := 1;
    TopicName := 'habarichat';
    if InputQuery('Enter chat', 'Chat name:', TopicName) then
    begin
      HabariExpress.OptionsDestination.DestinationName := TopicName;
      HabariExpress.OptionsConsumer.Retroactive := True;
    end else
    begin
      Exit;
    end;
    NickName := 'Nick';
    if not InputQuery('Enter nickname', 'Your nickname:', NickName) then
    begin
      Exit;
    end;
  end else begin
    ActionConnect.Caption := 'Connect';
    ActionConnect.ImageIndex := 0;
  end;

  ActionConnect.Checked := not ActionConnect.Checked;
  ActionOptions.Enabled := not ActionConnect.Checked;
  ActionSend.Enabled := ActionConnect.Checked;

  if ActionConnect.Checked then
  begin
    HabariExpress.Active := True;
    SendPublicInfo(Format('User %s entered the chat', [NickName]));
    StatusBar1.SimpleText := Format('Connected with %s on topic %s as user %s',
      [HabariExpress.Host, HabariExpress.OptionsDestination.DestinationName, NickName]);
  end
  else
  begin
    SendPublicInfo(Format('User %s has left the chat', [NickName]));
    HabariExpress.Active := False;
    StatusBar1.SimpleText := 'Not connected';
  end;

end;

procedure TForm1.ActionSendExecute(Sender: TObject);
var
  Txt: string;
  Msg: IMessage;
begin
  if InputQuery('Enter message', 'Text:', Txt) then
  begin
    Msg := HabariExpress.Session.CreateTextMessage(Txt);
    Msg.Properties.SetString('nickname', NickName);
    HabariExpress.MessageProducer.Send(Msg);
  end;
end;

procedure TForm1.ActionOptionsExecute(Sender: TObject);
var
  Txt: string;
begin
  Txt := DEFAULT_BROKER_URL;
  if InputQuery('Choose server', 'Server URL:', Txt) then
  begin
    HabariExpress.Host := Txt;
  end;
end;

end.

